# GPXLoad:

**GPX file Import / Export** for **Signal K Server**.

- Allows the upload of selected Routes and Waypoints in GPX files to a SignalK server

- Exports route and waypoint resources from Signal K server to a GPX file, preserving their UUIDs, in order to avoid resource duplication if re-imported.

---
### __Note -__ GPXLoad no longer acts as a resource provider for the following paths:

```
./resources/routes

./resources/waypoints

./vessels/self/navigation/courseGreatCircle/activeRoute/href

./vessels/self/navigation/courseGreatCircle/activeRoute/startTime

./vessels/self/navigation/courseGreatCircle/nextPoint/position

./vessels/self/navigation/courseGreatCircle/nextPoint/bearingTrue
```

To service these paths you will need to have an appropriate plugin installed on the Signal K server:

- `Routes` and `Waypoints`: A resource provider such as [sk-resource-fs](https://www.npmjs.com/package/sk-resources-fs) should be used. 

    _Note: `sk-resource-fs` will enable you to continue using your existing routes and waypoints, just enter path to your exisiting resources in the configuration._

- `Course data`: The Freeboard Helper plugin [freeboard-sk-plugin](https://www.npmjs.com/package/freeboard-sk-plugin) can be used as a provider for `activeRoute` and `nextPoint` paths. 

---

## Operation:

**To Import a GPX file:**

1) Open the Web App at the url: *http://signalk-server/gpxload/* 

2) Select the **Import GPX** tab and click **Open GPX file** 

3) Select a GPX file.

4) Select some or all of the Routes, Waypoints and Tracks from the displayed list.

5) To import just selected resources of a particular type click the **Load** button located within that resources group. To import all selected resources click **Load Selected** 

--- 
**To Export resources to a GPX file:**

1) Open the Web App at the url: *http://signalk-server/gpxload/* 

2) Select the **Export to GPX** tab and a list of available resources are displayed. 
Click **Refresh** if you want to re-load the list of resources from the Signal K server.

3) Select the Routes, Waypoints and Tracks from the displayed list that you want saved to the 
GPX file.

4) Click **Save** to export selected resources to file. 


**Note:** 

- GPXLoad preserves the uuids of resources exported from Signal K server in the GPX file, so if these GPX files are re-imported they will update the corresponding resource on the Signal K server rather than create a new resource.

- GPX files containing elements without Signal K UUID values will have UUIDs assigned each time the file is opened (or re-opened) in the WebUI. This will result in duplicate resources on the Signal K server if a GPX file is: opened, resources imported, re-opened and the same resources imported.
